#include <bits/stdc++.h>
#include "code.h"
#define ALPHA_SIZE 26

using namespace std;

class cvor
{
public:
    bool kraj;
    cvor* deca[ALPHA_SIZE];
};

int itmem = 1;
cvor* memorija = (cvor*)(malloc(1000010*sizeof(cvor)));

void UbaciTrie(cvor* koren, char* niska, int duzina, int visina = 1)
{
    if (visina > duzina)
    {
        koren->kraj = true;
        return;
    }

    if (koren->deca[niska[visina] - 'a'] == 0x0)
    {
        koren->deca[niska[visina] - 'a'] = &memorija[itmem++];
        koren->deca[niska[visina] - 'a']->kraj = false;
        for (int i = 0; i < ALPHA_SIZE; ++i) koren->deca[niska[visina] - 'a']->deca[i] = 0x0;
    }

    UbaciTrie(koren->deca[niska[visina] - 'a'], niska, duzina, visina + 1);
}

int Poplocavanje(cvor* koren, cvor* korenkorenastiji, int it, int N, char* A)
{
    int rez1 = 0, rez2 = -1;
    if (koren == 0x0) return -1;
    if (it == N + 1 && koren->kraj) return 1;
    if (it > N) it -= N;
    rez1 = Poplocavanje(koren->deca[A[it] - 'a'], korenkorenastiji, it + 1, N, A);
    if (rez1 == -1 && koren->kraj) rez2 = Poplocavanje(korenkorenastiji, korenkorenastiji, it, N, A);
    if (rez1 != -1) return rez1;
    if (rez2 != -1) return rez2 + 1;
    return -1;
}

void ObrisiTrie(cvor* koren)
{
    if (koren == 0x0) return;
    for (int i = 0; i < ALPHA_SIZE; ++i) ObrisiTrie(koren->deca[i]);
    delete koren;
}

void shift(int N, char* A)
{
    char temp = A[1];
    for (int i = 1; i < N; ++i) A[i] = A[i + 1];
    A[N] = temp;
}

cvor* koren;

int Resi(int N, char* A, int M, int* L, char** B)
{
    if (memorija == 0x0)
        return 3;
    koren = &memorija[0];
    koren->kraj = false;
    for (int i = 0; i < ALPHA_SIZE; ++i) koren->deca[i] = 0x0;
    int rez = 1000000007, temp;
    for (int i = 1; i <= M; ++i)
        UbaciTrie(koren, B[i], L[i]);
    for (int i = 0; i < N; ++i)
    {
        shift(N, A);
        temp = Poplocavanje(koren, koren, 1, N, A);
        if (temp < rez && temp > 0) rez = temp;
    }
    //delete memorija;
    if (rez == 1000000007) return -1;
	return rez;
}