#include "code.h"
#include <bits/stdc++.h>

using namespace std;

int N, M;
map< string, int > vx;
vector< string > b;
vector< vector< int > > memo;

inline char At (string s, int i) {
    return s[((i % N) + N) % N];
}

string Slice (string s, int l, int r) {
    char* a = new char[r - l];
    for (int i = 0; i < r - l; i++) {
        a[i] = At(s, l + i);
    }
    return (string)a;
}

int Solve (string& s, int l, int r) {
    if (memo[l][r] != -1) {
        return memo[l][r];
    }
    else {
        if (vx[s.substr(l, r-l+1)] > 0) {
            memo[l][r] = 1;
            return 1;
        }
        else {
            //cout << vx[s.substr(l, r-l+1)] << " " << l << " " << r << " " << s << endl;
            int o = 1 << 28;
            int t;
            for (int i = l; i < r; i++) {
                t = Solve(s, l, i) + Solve (s, i+1, r);
                if (t < o) {
                    o = t;
                }
            }
            memo[l][r] = o;
            return o;
        }
    }
}

int Resi(int N, char* A, int M, int* L, char** B) {

    string a = A+1;
    int k = N;
    string t;
    bool f;
    while (k > 1) {
        f = true;
        t = a.substr(0, N / k);
        for (int i = 0; i < N; i++) {
            if (t[i % (N / k)] != a[i]) {
                f = false;
                break;
            }
        }
        if (f) {
            a = t;
            N /= k;
            break;
        }
        else {
            while (N % k) {
                k--;
            }
        }
    }

    b.resize(N+1);
    memo.resize(N, vector< int > (N, -1));

    for (int i = 1; i <= M; i++) {
        b[i] = B[i] + 1;
        vx[b[i]] = i;
        //cout << b[i] << " " << vx[b[i]] << endl;
    }
    Solve (a, 0, N-1);

    if (memo[0][N-1] >= (1 << 28)) {
        N *= 2;
        //memo.clear();
        memo.resize(N, vector< int > (N, -1));
        a += a;
        Solve(a, 0, N-1);
    }

    return memo[0][N-1];
}