#include "code.h"
#include <bits/stdc++.h>

using namespace std;

int n;
map< string, int > vx;
int memo[1000][1000];

inline char At (string& s, int i) {
    return s[((i % n) + n) % n];
}

string Slice (string& s, int l, int r) {
    //cout << " slicin ";
    string a;
    for (int i = 0; i <= r - l; i++) {
        //cout << "******* " << At (s, l + i) << endl;
        a += At(s, l + i);
    }
    //cout << l << " " << r << endl;
    //cout << a << endl;
    return a;
}

int Solve (string& s, int l, int r) {
    //cout << l << " " << r << " ";
    int x = min (l / n, r / n);
    l -= x * n;
    r -= x * n;
    if (memo[l][r] == -2) {
        memo[l][r] = -1;

        //cout << "*" << Slice (s, l, r) << " " << vx[Slice (s, l, r)];
        if (vx[Slice (s, l, r)] > 0) {
            memo[l][r] = 1;
            return 1;
        }
        else if (l != r) {
            int ls, rs;
            for (int i = l; i < r; i++) {
                ls = Solve(s, l, i);
                rs = Solve (s, i+1, r);
                if (ls > 0 && rs > 0) {
                    if (memo[l][r] == -1) {
                        memo[l][r] = ls + rs;
                    }
                    else {
                        memo[l][r] = min(memo[l][r], ls + rs);
                    }
                }
            }
        }
    }
    //cout << memo[l][r];
    return memo[l][r];
}

int Resi(int N, char* A, int M, int* L, char** B) {
    n = N;
    string a = A+1;
    int k = 1, maxb = 0;
    string t;
    bool f;
    while (k < n) {
        f = true;
        t = a.substr(0, k);
        for (int i = 0; i < n; i++) {
            if (t[i % k] != a[i]) {
                f = false;
                break;
            }
        }
        if (f) {
            n = k;
            break;
        }
        else {
            do {
                k++;
            } while (n % k > 0);
        }
    }

    for (int i = 0; i < 1000; i++) {
        for (int j = 0; j < 1000; j++) {
            memo[i][j] = -2;
        }
    }

    for (int i = 1; i <= M; i++) {
        vx[(string)(B[i] + 1)] = i;
        maxb = max (L[i], maxb);
        //cout << b[i] << " " << vx[b[i]] << endl;
    }
    int mins = Solve (a, 0, n-1);

    k = 1;
    int nn = n;
    while (nn <= 500) {
        k++;
        nn = k * n;

        for (int i = 0; i < nn; i++) {
            int t = Solve(a, i, nn-1 + i);
            if (mins == -1) {
                mins = t;
            }
            else if (t != -1) {
                mins = min (mins, t);
            }
        }
    }

    return mins;
}

/*for (int i = 0; i < nn; i++) {
        for (int j = 0; j < nn; j++) {
            cout << memo[i][j] << " ";
        }
        cout << endl;
    }*/

int main() {

    //ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//cerr.tie(0);

	string a;
	int m;
	vector<string> b;

	cin >> a >> m;
	b.resize(m);
	for (int i = 0; i < m; i++)
		cin >> b[i];


	int n = a.size();
	char* A = new char[n+2];
	A[0] = A[n+1] = 0;
	copy(a.begin(), a.end(), A+1);

	char** B = new char*[m+1];
	int* L = new int[m+1];

	for (int i=1; i<=m; i++) {
		L[i] = b[i-1].size();
		B[i] = new char[L[i] + 2];
		B[i][0] = B[i][L[i]+1] = 0;
		copy(b[i-1].begin(), b[i-1].end(), B[i]+1);
	}


	cout << Resi(n, A, m, L, B) << '\n';
}