#include <bits/stdc++.h>
#define v_gr 100010
#define n_gr 850
using namespace std;


int mem[134217728]; // 128 MB
int *tekuca;
struct cvor
{
    int tip;
    int *ima;
    void uzmimem(int koliko)
    {
        ima=tekuca;
        tekuca+=koliko;
        for(int i=0;i<koliko;++i)ima[i]=0;
    }
};
cvor drvo[2048][2048];
bool vec[2048][2048];
int vv;
int upx,upy,upz,ups;
void promeni(int i, int j, int levo, int desno, int gore, int dole, bool rekurzija)
{
    if((desno-levo)*(dole-gore)<128)return;
    //ako ne spada
    if(levo>upx)return;
    if(desno<=upx)return;
    if(gore>upy)return;
    if(dole<=upy)return;
    // ako spada
    --drvo[i][j].ima[ups];
    ++drvo[i][j].ima[upz];
    // rekurzija
    if(!rekurzija)return;
    if(desno-levo>dole-gore)
    {
        int sredx = (levo+desno)/2;
        int sredy = (gore+dole)/2;
        promeni(2*i,j,levo,sredx,gore,dole,true);
        promeni(2*i+1,j,sredx,desno,gore,dole,true);
        if(dole-gore==1)return;
        promeni(i,2*j,levo,desno,gore,sredy,false);
        promeni(i,2*j+1,levo,desno,sredy,dole,false);
    }
    else
    {
        int sredx = (levo+desno)/2;
        int sredy = (gore+dole)/2;
        promeni(i,2*j,levo,desno,gore,sredy,true);
        promeni(i,2*j+1,levo,desno,sredy,dole,true);
        if(desno-levo==1)return;
        promeni(2*i,j,levo,sredx,gore,dole,false);
        promeni(2*i+1,j,sredx,desno,gore,dole,false);
    }
}
int ima[104];
int uplevo,updesno,upgore,updole;
void popuni(int i, int j, int levo, int desno, int gore, int dole)
{
    // ako se ne poklapa
    if(levo>=updesno)return;
    if(desno<=uplevo)return;
    if(gore>=updole)return;
    if(dole<=upgore)return;
    // ako se skroz poklapa
    if(levo>=uplevo)
        if(desno<=updesno)
            if(gore>=upgore)
                if(dole<=updole)
    {
        if((desno-levo)*(dole-gore)<128)
        {
            printf("rucno\n%d-%d %d-%d", 1024+levo,1024+desno,1024+gore,1024+dole);
            for(int ii=1024+levo,krajx=1024+desno;ii<krajx;++ii)
                for(int jj=1024+gore,krajy=1024+dole;jj<krajy;++jj)
                    ++ima[drvo[ii][jj].tip];
        }
        else
        {
            int *ja=drvo[i][j].ima;
            for(int ii=1;ii<=vv;++ii)ima[ii]+=ja[ii];
        }
        return;
    }
    //ako je 1x1 onda se ili skroz ili uopste...
    //dakle, delimicno i povrs>1
    if(desno-levo>dole-gore)
    {
        int sred = (levo+desno)/2;
        popuni(2*i,j,levo,sred,gore,dole);
        popuni(2*i+1,j,sred,desno,gore,dole);
    }
    else
    {
        int sred = (gore+dole)/2;
        popuni(i,2*j,levo,desno,gore,sred);
        popuni(i,2*j+1,levo,desno,sred,dole);
    }
}



int glupoost[v_gr];
void Resi(int n, int m, int q, int v, int **a, int *b, int *x1, int *y1, int *x2, int *y2, int *odg)
{
    if(q<=0)
    {
        int trodg = 1;
        for(int up=1;up<=q;++up)
        {
            if(y2[up]==-1)
            {
                a[x1[up]][y1[up]]=x2[up];
            }
            else
            {
                for(int i=1;i<=v;++i)glupoost[i]=0;
                for(int i=x1[up];i<=x2[up];++i)
                    for(int j=y1[up];j<=y2[up];++j)
                        ++glupoost[a[i][j]];
                int pokl=0;
                for(int i=1;i<=v;++i)if(glupoost[i]==b[i])++pokl;
                odg[trodg]=pokl;
                ++trodg;
            }
        }
        return;
    }
    if(v<=100)
    {
        // namestam 2D stablo
        int zaz=v+2;
        tekuca = mem;
        for(int i=1,poslsti=1,duzina=1024;i<2048;++i)
        {
            if(i=poslsti*2)
            {
                poslsti=i;
                duzina/=2;
            }
            for(int j=1,poslstj=1,visina=1024;j<2048;++j)
            {
                if(j=poslstj*2)
                {
                    poslstj=j;
                    visina/=2;
                }
                if(duzina*visina<=128)
                    drvo[i][j].ima=nullptr;
                else
                    drvo[i][j].uzmimem(zaz);
            }
        }
        // sad ga punim
        // 1. dno
        for(int i=1024;i<2048;++i)
            for(int j=1024;j<2048;++j)
                drvo[i][j].tip=0;
        for(int i=1;i<=n;++i)
            for(int j=1;j<=m;++j)
                drvo[1024+i][1024+j].tip=a[i][j];
        // 2. ostalo
        for(int i=1023,posli=1023,duzina=2;i>0;--i)
        {
            if(i*2<posli)
            {
                posli=i;
                duzina*=2;
            }
            for(int j=1023,poslj=1023,visina=2;j>0;--j)
            {
                if(j*2<poslj)
                {
                    poslj=j;
                    visina*=2;
                }
                if(duzina*visina<128)continue;
                if(duzina*visina==128)
                {
                    //rucno, svaki
                    int *ja=drvo[i][j].ima;
                    int levo,desno,gore,dole;
                    desno=2048-(posli-i)*duzina;
                    levo=desno-duzina;
                    dole=2048-(poslj-j)*visina;
                    gore=dole-visina;
                    for(int ii=levo;ii<desno;++ii)
                        for(int jj=gore;jj<dole;++jj)
                            ++ja[drvo[1024+ii][1024+jj].tip];
                }
                else
                {
                    //rekurzivno, sabiram
                    if(duzina>visina)
                    {
                        int *ja=drvo[i][j].ima;
                        int *lev=drvo[i*2][j].ima;
                        int *des=drvo[i*2+1][j].ima;
                        for(int i=1;i<=v;++i)
                            ja[i]=lev[i]+des[i];
                    }
                    else
                    {
                        int *ja=drvo[i][j].ima;
                        int *lev=drvo[i][j*2].ima;
                        int *des=drvo[i][j*2+1].ima;
                        for(int i=1;i<=v;++i)
                            ja[i]=lev[i]+des[i];
                    }
                }
            }
        }
        // sad smo popunili tabelu
        vv=v;
        int trodg=1;
        for(int up=1;up<=q;++up)
        {
            if(y2[up]==-1)
            {
                upx=x1[up];
                upy=y1[up];
                upz=x2[up];
                ups=drvo[1024+upx][1024+upy].tip;
                drvo[1024+upx][1024+upy].tip=upz;
                promeni(1,1,0,0,1024,1024,true);
            }
            else
            {
                for(int i=1;i<=v;++i)ima[i]=0;
                //...
                uplevo = x1[up];
                upgore = y1[up];
                updesno = x2[up] + 1;
                updole = y2[up] + 1;
                popuni(1,1,0,0,1024,1024);
                //...
                int pokl=0;
                for(int i=1;i<=v;++i)if(ima[i]==b[i])++pokl;
                odg[trodg]=pokl;
                ++trodg;
            }
        }
    }
}