#include "code.h"

#include<bits/stdc++.h>

using namespace std;

struct ubime{
    int brploca,brpolja;
};

bool isti(int poc1,int poc2,int duz,char *A,int &N)
{
    for(int i=0;i<duz;i++)
        if(A[poc1+i]!=A[poc2+i])
            return false;
    return true;
}

bool proveraA(int &i,char* A,int &N)
{
    bool moze=true;
    for(int j=i;j<N;j+=i)
    {
     if(!isti(1,j+1,i,A,N))
            moze=false;
    }
    return moze;
}

vector< vector<ubime> > pom;

bool proveraM(int &kraj,int &koji,int &duzina,char* A,char** B)
{
    for(int i=0;i<duzina;i++)
    {
        if(A[kraj-duzina+1+i]!=B[koji][i+1])
            return false;
    }
    return true;
}

int Resi(int N, char* A, int M, int* L, char** B)
{
    int minimum=N;
    for(int i=1;i<N;i++)
    {
        if(N%i==0 && proveraA(i,A,N))
        {
            minimum=i;
            break;
        }
    }
    if(minimum==1)
    {
        bool da;
        for(int i=1;i<=M;i++)
        {
            da=false;
            for(int j=1;j<=L[i];j++)
            {
                if(B[i][j]!=A[1])
                    da=true;
            }
            if(!da)
                return 1;
        }
        return -1;
    }
    int maximum=0;
    for(int i=1;i<=M;i++)
        maximum=max(maximum,L[i]);
    char* S = new char[N+2*minimum+2];
    S[0]=S[N+2*minimum+1]=0;
    for(int i=1;i<=N;i++)
    {
        S[i]=A[i];
    }
    for(int i=1;i<=minimum;i++)
    {
        S[N+i]=A[i];
        S[minimum+N+i]=A[i];
    }
    ubime nozem;
    pom.resize(N+minimum+maximum+1);
    for(int i=0;i<N+minimum+maximum+1;i++)
        pom[i].push_back({0,0});
    for(int i=N+1;i<N+minimum+maximum+1;i++)
    {
        for(int j=1;j<=M;j++)
        {
            if(proveraM(i,j,L[j],S,B))
            {
                for(int r=0;r<pom[i-L[j]].size();r++)
                {
                    nozem=pom[i-L[j]][r];
                    nozem.brploca++;
                    nozem.brpolja+=L[j];
                    pom[i].push_back(nozem);
                }
            }
        }
    }
    int rez=INT_MAX;
    for(int i=N+1;i<N+maximum+minimum+1;i++)
    {
        for(int j=0;j<pom[i].size();j++)
        {
            if(pom[i][j].brpolja>=minimum && rez>pom[i][j].brploca && pom[i][j].brpolja%minimum==0)
            rez=pom[i][j].brploca;
        }
    }
    if(rez==INT_MAX)
    {
        return -1;
    }
	return rez;
}