#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define fr first
#define sc second
#define lb lower_bound
#define up upper_bound
#define pii pair<int,int>
#define vi vector<int>
#define FOR(i,x,y) for(int i=x; i<=y; i++)

const int mod=int(1e9+7),MAXN=850,MAXV=int(1e5+5),MAXQ=10005;

int n,m,q,v,a[MAXN][MAXN],br[MAXV],b[MAXV],seg[MAXV][50],sp[MAXV],x1[MAXQ],y1[MAXQ],x2[MAXQ],y2[MAXQ];
vi rez;

void init(int v, int idx, int i1, int j1, int i2, int j2)
{
    if (i1>i2 || j1>j2)
        return;

    if (i1==i2 && j1==j2)
    {
        seg[v][idx]=int(sp[v]==a[i1][j1]);
        return;
    }

    init(v,idx*4+1,i1,j1,(i1+i2)/2,(j1+j2)/2);
    init(v,idx*4+2,i1,(j1+j2)/2+1,(i1+i2)/2,j2);
    init(v,idx*4+3,(i1+i2)/2+1,j1,i2,(j1+j2)/2);
    init(v,idx*4+4,(i1+i2)/2+1,(j1+j2)/2+1,i2,j2);

    seg[v][idx]=seg[v][idx*4+1]+seg[v][idx*4+2]+seg[v][idx*4+3]+seg[v][idx*4+4];
}

int get(int v, int idx, int i1, int j1, int i2, int j2, int I1, int J1, int I2, int J2)
{
    if (i1==I1 && i2==I2 && j1==J1 && j2==J2)
        return seg[v][idx];
    if (I1>i2 || J1>j2 || I2<i1 || J2<j1)
        return 0;

    return get(v,idx*4+1,i1,j1,(i1+i2)/2,(j1+j2)/2,I1,J1,min((i1+i2)/2,I2),min((j1+j2)/2,J2))+

    get(v,idx*4+2,i1,(j1+j2)/2+1,(i1+i2)/2,j2,I1,max(J1,(j1+j2)/2+1),min(I2,(i1+i2)/2),J2)+

    get(v,idx*4+3,(i1+i2)/2+1,j1,i2,(j1+j2)/2,max(I1,(i1+i2)/2+1),J1,I2,min(J2,(j1+j2)/2))+

    get(v,idx*4+4,(i1+i2)/2+1,(j1+j2)/2+1,i2,j2,max(I1,(i1+i2)/2+1),max(J1,(j1+j2)/2+1),I2,J2);
}

void upd(int v, int idx, int i1, int j1, int i2, int j2, int I, int J, int X)
{
    if (i1==i2 && j1==j2)
    {
        seg[v][idx]=X;
        return;
    }

    if (I<=(i1+i2)/2 && J<=(j1+j2)/2)
        upd(v,idx*4+1,i1,j1,(i1+i2)/2,(j1+j2)/2,I,J,X);

    if (I<=(i1+i2)/2 && J>(j1+j2)/2)
        upd(v,idx*4+2,i1,(j1+j2)/2+1,(i1+i2)/2,j2,I,J,X);

    if (I>(i1+i2)/2 && J<=(j1+j2)/2)
        upd(v,idx*4+3,(i1+i2)/2+1,j1,i2,(j1+j2)/2,I,J,X);

    if (I>(i1+i2)/2 && J>(j1+j2)/2)
        upd(v,idx*4+4,(i1+i2)/2+1,(j1+j2)/2+1,i2,j2,I,J,X);

    seg[v][idx]=seg[v][idx*4+1]+seg[v][idx*4+2]+seg[v][idx*4+3]+seg[v][idx*4+4];
}

int sab5()
{
    set<int> s;
    FOR(i,1,n)
        FOR(j,1,m)
            s.insert(a[i][j]);
    FOR(i,1,q)
        if (y2[i]==-1)
            s.insert(x2[i]);

    int V=0;
    for (auto i:s)
    {
        V++;
        sp[i]=V;
    }

    FOR(i,1,n)
        init(i,0,1,1,n,m);

    FOR(i,1,q)
    {
        if (y2[i]==-1)
            upd(sp[x2[i]],int(0),int(1),int(1),n,m,x1[i],y1[i],x2[i]);
        else
        {
            int t=0;
            FOR(j,1,V)
                if (get(j,0,1,1,n,m,x1[i],y1[i],x2[i],y2[i])==b[j])
                    t++;

            rez.pb(t);
        }
    }
}

void Resi(int N, int M, int Q, int V, int** A, int* B, int* X1, int* Y1, int* X2, int* Y2, int* o)
{
	int st2=1;
	if (V>100) st2=0;
		else
	FOR(i,1,Q)
		if (Y2[i]==-1)
		{
			st2=0;
			break;
		}
		
	if ((N<=100 && M<=100 && Q<=100 && V<=100) || (st2) || (V<=50))
	{
		int t=0;
		FOR(i,1,Q)
		{
			if (Y2[i]==-1)
				A[X1[i]][Y1[i]]=X2[i];
			else
			{
				int br[105],rez=0;
				FOR(i,1,V)
					br[i]=0;
				FOR(i1,X1[i],X2[i])
					FOR(j1,Y1[i],Y2[i])
						br[A[i1][j1]]++;
				FOR(i,1,V)
					if (br[i]==B[i])
						rez++;
				t++;
				o[t]=rez;
			}
		}
		return;
	}
	
	n=N;
	m=M;
	q=Q;
	v=V;
	
	FOR(i,1,n)
		FOR(j,1,m)
			a[i][j]=A[i][j];
		
	FOR(i,1,v)
		b[i]=B[i];
	
	FOR(i,1,q)
	{
		x1[i]=X1[i];
		y1[i]=Y1[i];
		x2[i]=X2[i];
		y2[i]=Y2[i];
	}
	
	sab5();
	
	FOR(i,0,rez.size()-1)
		o[i+1]=rez[i];
	
}