#ifndef __CODE_H__
#define __CODE_H__

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
/*
	N i M su dimenzije matrice, Q je broj upita,
	V je broj razlicitih brojeva u matrici.

	Svaki upit ima ili 4 broja x1, y1, x2, y2 >= 0,
	ili u slucaju apdejta ima x1, y1 = koordinate, x2 = nova
	vrednost, y2 = -1
*/



int VSeg[1000][1000][1000];//Bice implicitno kasnije

void Update(int x,int y,int Position,int value,int N,int M){//x,y su za N odnosno M veci od Njihovih realnih vrednosti
    //Position je null indeksiran;
    //Value je 0 ili 1
VSeg[x][y][Position]=value;
int counter=0;
for(int i=y/2;i>=1;i/=2){
        VSeg[N][i][Position]=0;
        if(i*2<=M){    VSeg[N][i][Position]+= VSeg[1][i*2][Position];}
    if(i*2+1<=M)
    VSeg[N][i][Position]+= VSeg[N][i*2+1][Position];
}  for(int j=x/2;j>=1;j/=2){
for(int i=y;i>=1;i/=2){
  
            VSeg[j][i][Position]=0;
    if(j*2<=N){
      VSeg[j][i][Position]+=  VSeg[j*2][i][Position];
    }
      if(j*2+1<=N)
       VSeg[j][i][Position]+=VSeg[j*2+1][i][Position];
    }
}
}
int Calculate(int LV,int RV,int LM,int RM,int Position){
int sol=0;
vector<int> Indices;
vector<int> BigIndices;
while(LM!=RM){
    if(LM%2){
        Indices.push_back(LM);
        LM++;
    }
    if(!(RM%2)){
        Indices.push_back(RM);
        RM--;
    }
    RM/=2;
    LM/=2;
}
 Indices.push_back(RM);

while(LV!=RV){
    if(LV%2){
        BigIndices.push_back(LV);
        LV++;
    }
    if(!(RV%2)){
        BigIndices.push_back(RV);
        RV--;
    }
    LV/=2;
    RV/=2;
}
 BigIndices.push_back(RV);

 for(int i=0;i<BigIndices.size();i++){
    for(int j=0;j<Indices.size();j++){
        sol+=VSeg[BigIndices[i]][Indices[j]][Position];
    }
 }
 return sol;
}
void Resi(int N, int M, int Q, int V, int** A, int* B,int* X1, int* Y1, int* X2, int* Y2, int* O){

for(int x=N;x<N*2;x++){
for(int i=M;i<M*2;i++){

Update(x,i,A[x-N+1][i-M+1]-1,1,N,M);
}

}
int Br=0;
for(int i=1;i<=Q;i++){
    if(Y2[i]==-1){
        Update(N+X1[i]-1,M-1+Y1[i],A[X1[i]][Y1[i]]-1,0,N,M);
          Update(N+X1[i]-1,M-1+Y1[i],X2[i]-1,1,N,M);
          A[X1[i]][Y1[i]]=X2[i];
    }
    else{
            Br++;

   for(int x=0;x<V;x++){
    if(Calculate(X1[i]+N-1,X2[i]+N-1,Y1[i]+M-1,Y2[i]+M-1,x)==B[x+1]){
        O[Br]++;
    }
   }

    }
}

}

#endif /* __CODE_H__ */