#include <bits/stdc++.h>
#include "code.h"
#define ALPHA_SIZE 26

using namespace std;

class cvor
{
public:
    bool kraj;
    int deca[ALPHA_SIZE];
};

int itmem = 1;
cvor* memorija = (cvor*)(malloc(1000010*sizeof(cvor)));

void UbaciTrie(int koren, char* niska, int duzina, int visina = 1)
{
    if (koren == -1)
        return;
    if (visina > duzina)
    {
        memorija[koren].kraj = true;
        return;
    }

    if (memorija[koren].deca[niska[visina] - 'a'] == -1)
    {
        memorija[koren].deca[niska[visina] - 'a'] = itmem++;
        memorija[memorija[koren].deca[niska[visina] - 'a']].kraj = false;
        for (int i = 0; i < ALPHA_SIZE; ++i) memorija[memorija[koren].deca[niska[visina] - 'a']].deca[i] = -1;
    }

    UbaciTrie(memorija[koren].deca[niska[visina] - 'a'], niska, duzina, visina + 1);
}

int Poplocavanje(int koren, int it, int N, char* A)
{
    int rez1 = 0, rez2 = -1;
    if (koren == -1) return -1;
    if (it == N + 1 && memorija[koren].kraj) return 1;
    if (it > N) it -= N;
    rez1 = Poplocavanje(memorija[koren].deca[A[it] - 'a'], it + 1, N, A);
    if (rez1 == -1 && memorija[koren].kraj) rez2 = Poplocavanje(0, it, N, A);
    if (rez1 != -1) return rez1;
    if (rez2 != -1) return rez2 + 1;
    return -1;
}

/*void ObrisiTrie(int koren)
{
    if (koren == -1) return;
    for (int i = 0; i < ALPHA_SIZE; ++i) ObrisiTrie(memorija[koren].deca[i]);
    delete koren;
}*/

void shift(int N, char* A)
{
    char temp = A[1];
    for (int i = 1; i < N; ++i) A[i] = A[i + 1];
    A[N] = temp;
}

int koren = 0;

int Resi(int N, char* A, int M, int* L, char** B)
{
    if (memorija == nullptr)
        return 3;
    memorija[koren].kraj = false;
    for (int i = 0; i < ALPHA_SIZE; ++i) memorija[koren].deca[i] = -1;
    int rez = 1000000007, temp;
    for (int i = 1; i <= M; ++i)
        UbaciTrie(koren, B[i], L[i]);
    for (int i = 0; i < N; ++i)
    {
        shift(N, A);
        temp = Poplocavanje(koren, 1, N, A);
        if (temp < rez && temp > 0) rez = temp;
    }
    delete[] memorija;
    if (rez == 1000000007) return -1;
	return rez;
}