//#include "grader.cpp"
#include "code.h"
#include <stdio.h>
#include <set>
#include <vector>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <cstring>
#include <queue>
using namespace std;
#define mp make_pair
#define pb push_back
#define ll long long
bool ckmax(int &a, int b){ int c=a;a=max(a,b);return c!=a;}
bool ckmin(int &a, int b){ int c=a;a=min(a,b);return c!=a;}
bool ckmax(ll &a, ll b){ ll c=a;a=max(a,b);return c!=a;}
bool ckmin(ll &a, ll b){ ll c=a;a=min(a,b);return c!=a;}
const ll mod=125458767879787;
const int N=505;
const int inf=1e9;
ll hs[N],po[N],fw[N],bw[N],h2[N],table[N][N];
void ck(ll &x){ if(x<0) x+=mod;if(x>=mod) x-=mod;}
vector<int> E[N],R[N];
queue<int> q;
int dist[N];
bool was[N];
int BFS(int s, int n)
{
    int i;
    for(i=0;i<n;i++) was[i]=0,dist[i]=inf;
    q.push(s);dist[s]=1;was[s]=1;
    while(q.size())
    {
        int x=q.front();
        //printf("%i\n",x);
        q.pop();
        for(i=0;i<E[x].size();i++)
        {
            int y=E[x][i];
            if(!was[y])
            {
                //printf("%i -> %i\n",x,y);
                dist[y]=dist[x]+1;
                was[y]=1;
                q.push(y);
            }
        }
    }
    int ret=inf;
    for(i=0;i<R[s].size();i++)
    {
        //printf("%i -> %i = %i\n",s,R[s][i],dist[R[s][i]]);
        if(was[R[s][i]]) ckmin(ret,dist[R[s][i]]);
    }
    //printf("%i %i\n",s,ret);
    return ret;
    //if(!was[(n-s)%n]) return inf;
    //return dist[(n-s)%n];
}
bool can[N];
int Resi(int n, char* a, int m, int* len, char** b)
{
    int i,j;
    po[0]=1;for(i=1;i<=n;i++) po[i]=po[i-1]*26%mod;
    //for(i=1;i<=n;i++) hs[i]=hs[i-1]+(po[i-1]*(a[i]-'a'+1)%mod),ck(hs[i]);
    //for(i=n;i>=1;i--) h2[i]=h2[i+1]*26%mod+(a[i]-'a'+1),ck(h2[i]);
    for(j=1;j<=n;j++)
    {
        for(i=j;i<=n;i++)
        {
            table[j][i]=table[j][i-1]+(po[i-j]*(a[i]-'a'+1)%mod),ck(table[j][i]);
        }
    }
    int t;
    for(t=1;t<=n;t++)
    {
        bool ok=1;
        for(i=t+1;i<=n;i+=t)
        {
            if(table[i][i+t-1]!=table[1][t]) ok=0;
        }
        if(ok){ n=t;break;}
    }
    for(i=1;i<=n;i++) hs[i]=table[1][i];//hs[i]=hs[i-1]+(po[i-1]*(a[i]-'a'+1)%mod),ck(hs[i]);
    for(i=n;i>=1;i--) h2[i]=table[i][n];//h2[i]=h2[i+1]*26%mod+(a[i]-'a'+1),ck(h2[i]);
    //for(i=1;i<=n;i++) printf("%lld ",hs[i]);printf("\n");
    //for(i=1;i<=n;i++) printf("%lld ",h2[i]);printf("\n");
    for(j=1;j<=m;j++)
    {
        fw[0]=0;
        for(i=1;i<=len[j];i++) fw[i]=fw[i-1]+(po[i-1]*(b[j][i]-'a'+1)%mod),ck(fw[i]);
        bw[len[j]+1]=0;
        for(i=len[j];i>=1;i--) bw[i]=bw[i+1]*26%mod+(b[j][i]-'a'+1),ck(bw[i]);
        //for(i=1;i<=len[j];i++) printf("%lld ",fw[i]);printf("\n");
        //for(i=1;i<=len[j];i++) printf("%lld ",bw[i]);printf("\n");
        for(i=0;i<=len[j];i++)
        {
            if(fw[i]==h2[n-i+1] && bw[i+1]==hs[len[j]-i])
            {
                E[(n-i)%n].pb((len[j]-i)%n);
                //can[(len[j]-i)%n]=1;
                R[(len[j]-i)%n].pb((n-i)%n);
                //printf("1:%i %i %i\n",j,(n-i)%n,(len[j]-i)%n);
            }
        }
        for(i=1;i<=n-len[j]+1;i++)
        {
            if(fw[len[j]]==table[i][i+len[j]-1])
            {
                //printf("2:%i %i %i\n",j,i-1,(i+len[j]-1)%n);
                E[i-1].pb((i+len[j]-1)%n);
            }
        }
    }
    int sol=inf;//can[0]=1;
    for(i=0;i<n;i++) ckmin(sol,BFS(i,n));
    if(sol>=inf) return -1;
    return sol;
}
//---------------------//
/*
char b[N][N];
int len[N];
char a[N];
int main()
{
    int n,m,i;
    scanf("%s",a+1);
    n=strlen(a+1);
    scanf("%i",&m);
    for(i=1;i<=m;i++) scanf("%s",b[i]+1),len[i]=strlen(b[i]+1);
    printf("%i\n",Resi(n,a,m,len,b));
    return 0;
}

*/