#include "code.h"
#include<bits/stdc++.h>
#define MAX_N 505
#define MAX_M 100005

using namespace std;

int N;
//char A[MAX_N];
int M;
vector<int> adj[MAX_N], revadj[MAX_N];
int dist[MAX_N], revdist[MAX_N];
queue<int> q;

void BFS(int v){
	//memset(dist, N+1, sizeof(dist));
	for(int i=0; i<N; ++i)dist[i]=N+1;
	dist[v]=0;
	q.push(v);
	while(!q.empty()){
		int cur=q.front();
		q.pop();
		int d=adj[cur].size();
		for(int i=0; i<d; ++i){
			int u=adj[cur][i];
			if(dist[u]==N+1){
				dist[u]=dist[cur]+1;
				q.push(u);
			}
		}
	}
}

void revBFS(int v){
	for(int i=0; i<N; ++i)revdist[i]=N+1;
	revdist[v]=0;
	q.push(v);
	while(!q.empty()){
		int cur=q.front();
		q.pop();
		int d=revadj[cur].size();
		for(int i=0; i<d; ++i){
			int u=revadj[cur][i];
			if(revdist[u]==N+1){
				revdist[u]=revdist[cur]+1;
				q.push(u);
			}
		}
	}
}

int Resi(int n, char* A, int m, int* L, char** B)
{
	//A=a;
	A=A+1;
	L=L+1;
	N=n;
	for(int i=1; i<N; ++i){
		if(N%i!=0)continue;
		bool match=1;
		for(int j=0; j<N; ++j){
			if(A[j]!=A[(j+i)%N]){
				match=0;
				break;
			}
		}
		if(match){
			N=i;
			break;
		}
	}
	for(int i=0; i<m; ++i){
		//Pokusacemo da matchujemo B[i] i neku poziciju u A
		for(int j=0; j<N; ++j){
			//Ovo je ta pozicija u A
			bool match=1;
			for(int k=0; k<L[i]; ++k){//Ovo radi u O(N * suma L[i])
				//cout<<B[i+1][k+1]<<" "<<A[(k+j)%N]<<endl;
				if(B[i+1][k+1]!=A[(k+j)%N]){
					match=0;
					break;
				}
			}
			if(match){
				adj[j].push_back((j+L[i])%N);
				revadj[(j+L[i])%N].push_back(j);
			}
		}
	}
	/*for(int i=0; i<N; ++i){
		printf("adj[%d]:", i);
		for(int j=0; j<adj[i].size(); ++j){
			printf("%d ", adj[i][j]);
		}
		printf("\n");
	}*/
	int totmin=N+1;
	for(int i=0; i<N; ++i){
		BFS(i);
		revBFS(i);
		/*printf("BFS(%d):\n", i);
		for(int j=0; j<N; ++j){
			printf("dist[%d]=%d\n", j, dist[j]);
		}*/
		int locmin=N+1;
		for(int j=0; j<N; ++j){
			if(dist[j]+revdist[j]<locmin && j!=i){
				locmin=dist[j]+revdist[j];
			}
		}
		if(locmin<totmin)totmin=locmin;
	}
	if(totmin==N+1)return -1;
	else return totmin;
}