#include <bits/stdc++.h>
#include "code.h"
#define maxN 513
#define maxM 100013
#define inf 1000013

using namespace std;

struct node
{
    set<int> children;
    int visited = 0;
};

node v[maxN];

string toString(int n,char a[])
{
    string sol;
    for(int i=1;i<=n;i++)
        sol+=a[i];
    return sol;
}

void dfs(int x,int& sol,int sloj)
{
    //cout <<"sloj: "<< sloj <<"cvor: "<< x << endl;
    if(v[x].visited)  {sol = min(sol,sloj-v[x].visited); return;}

    v[x].visited = sloj;
    for(int i : v[x].children)
        dfs(i,sol,sloj+1);
}

int resi(int n, string a, int m, int* L, char** B)
{
    int sol = inf;
    a=a+a;

    for(int i=1;i<=m;i++)
    {
        string b = toString(L[i],B[i]);

        int prvi=0;
        while(prvi < a.size())
        {
            int br = a.find(b,prvi);
            if(br==-1) break;
            if(br== n) break;

            prvi = br+1;
            //cout << "br je " << br <<" a n je " << n <<" a ubacuje se "<<(br+b.size())%n<<endl;
            v[br%n].children.insert((br+b.size())%n);
            //cout << br << endl;
        }
    }
    for(int i=0;i<n;i++)
        if(!v[i].visited) dfs(i,sol,1);
    return sol;
}

string podeli(string str)
{
    for(int n=1;n<=str.size();n++) if(str.size()%n==0)
    {
        bool jeste = true;
        string s = str.substr(0,n);
        for(int i=0;i<str.size();i+=n) if(s!=str.substr(i,n)) {jeste = false; break;}
        if(jeste) return s;
    }
    return str;
}

int Resi(int n, char* A, int m, int* L, char** B)
{
    string a = toString(n,A);
    //cout << podeli(a) <<endl;
    return resi(podeli(a).size(),a,m,L,B);
}