#include "code.h"
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define maxM 100000
#define maxN 500

int n, m, l[maxM];
char* a;
char* b[maxM];

int p;
ll h[2*maxN];
vector<int> g[maxN];
int fw[maxN][maxN];

namespace hsh {
    const ll X = 4777;
    ll Xn;
    ll calc(int i, int j) {
        return h[j] - (i == 0 ? 0LL : h[i-1]);
    }
    ll sum(char* chr, int l) {
        ll cur = 1LL, sum = 0LL;
        for (int i = 0; i < l; i++) {
            sum += cur * chr[i];
            cur *= X;
        }
        return sum;
    }
}

int find_p() {
    for (int k = 1; k < n; k++) {
        bool f = true;
        for (int i = k; i < n; i++)
            if (a[i] != a[i - k]) {
                f = false;
                break;
            }
        if (f)
            return k;
    }
    return n;
}

void init_connect() {
    ll cur = 1LL, sum = 0LL;
    for (int i = 0; i < 2*maxN; i++) {
        sum += cur * a[i % n];
        cur *= hsh::X;
        h[i] = sum;
    }
    hsh::Xn = cur;
}

void connect(int id) {
    ll haash = hsh::sum(b[id], l[id]);
    ll cur = 1LL;
    for (int i = 0; i < n; i++, cur *= hsh::X)
        if (hsh::calc(i, i + l[id] - 1) == haash*cur)
            g[i].push_back((i + l[id]) % n);
}

int min_cycle() {
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            fw[i][j] = n + 1;
    for (int i = 0; i < n; i++)
        for (auto v: g[i])
            fw[i][v] = 1;
    for (int a = 0; a < n; a++)
        for (int b = 0; b < n; b++)
            for (int c = 0; c < n; c++)
                fw[b][c] = min(fw[b][c], fw[b][a] + fw[a][c]);
    int mn = n + 1;
    for (int i = 0; i < n; i++)
        mn = min(mn, fw[i][i]);
    return mn;
}

int Resi(int _n, char* _a, int _m, int* _l, char** _b) {
    n = _n, m = _m;
    a = _a + 1;
    for (int i = 0; i < m; i++)
        l[i] = _l[i + 1], b[i] = _b[i + 1] + 1;
    n = find_p();
    init_connect();
    for (int i = 0; i < m; i++)
        connect(i);
    int temp = min_cycle();
    return temp > n ? -1 : temp;
}