#include "code.h"
#include <bits/stdc++.h>
using namespace std;
const int maxN = 2*420;
const int maxV = (int)1e5;
const int maxQ = 10000;

/*
3 4 3 4

1 2 3 2
2 3 1 3
3 1 1 4

1 2 3 4

1  1 2 3 4
2  3 4 2
1  1 2 3 4
*/

namespace po_q {
    int n, m, q, v, zeros;
    int a[maxN][maxN], b[maxV], m_x1[maxQ], m_y1[maxQ], m_x2[maxQ], m_y2[maxQ];
    int cnt[maxV];


    void Resi_q(int _n, int _m, int _q, int _v, int** _a, int* _b, int* _x1, int* _y1, int* _x2, int* _y2, int* sol) {
        n = _n, m = _m, q = _q, v = _v;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                a[i][j] = _a[i+1][j+1] - 1;
        for (int i = 0; i < v; i++)
            b[i] = _b[i+1];
        for (int i = 0; i < q; i++)
            m_x1[i] = _x1[i+1] - 1, m_y1[i] = _y1[i+1] - 1, m_x2[i] = _x2[i+1] - 1, m_y2[i] = _y2[i+1] - 1;

        for (int i = 0; i < v; i++)
            if (b[i] == 0)
                zeros++;
        int t = 0;
        for (int i = 0; i < q; i++) {
            if (m_y2[i] == -2)
                a[m_x1[i]][m_y1[i]] = m_x2[i];
            else {
            //    sol[++t] = zeros;
                sol[++t] = 0;
                for (int x = m_x1[i]; x <= m_x2[i]; x++)
                    for (int y = m_y1[i]; y <= m_y2[i]; y++) {
                        cnt[a[x][y]]++;
                        /*
                        if (cnt[a[x][y]] == b[a[x][y]])
                            sol[t]++;
                        if (cnt[a[x][y]] == b[a[x][y]] + 1)
                            sol[t]--;
                        */
                    }
                for (int z = 0; z < v; z++)
                    if (b[z] == cnt[z])
                        sol[t]++;
                memset(cnt, 0, v*sizeof(int));
                    /*
                for (int x = m_x1[i]; x <= m_x2[i]; x++)
                    for (int y = m_y1[i]; y <= m_y2[i]; y++)
                        cnt[a[x][y]]--;
                        */
            }
        }
    }
}

namespace po_v {
    const int max_v = 100;
    int n, m, q, v, zeros;
    int a[maxN][maxN], b[max_v];
    int fen[maxN + 1][maxN + 1][max_v];

    void upd(int x, int y, int k, int d) {
      //  printf("upd(x=%d, y=%d, k=%d,d=%d)\n", x, y, k, d);
        for (; x <= n; x += x & (-x))
            for (int y1 = y; y1 <= m; y1 += y1 & (-y1))
                fen[x][y1][k] += d;
    }
    int sum(int x, int y, int k) {
        int ret = 0;
        for (; x > 0; x -= x & (-x))
            for (int y1 = y; y1 > 0; y1 -= y1 & (-y1))
                ret += fen[x][y1][k];
        return ret;
    }
    int query(int x1, int y1, int x2, int y2, int k) {
        return sum(x2, y2, k) - sum(x1 - 1, y2, k) - sum(x2, y1 - 1, k) + sum(x1 - 1, y1 - 1, k);
    }
    void Resi_v(int _n, int _m, int _q, int _v, int** _a, int* _b, int* m_x1, int* m_y1, int* m_x2, int* m_y2, int* sol) {
        n = _n, m = _m, q = _q, v = _v;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++) {
                a[i+1][j+1] = _a[i+1][j+1] - 1;
                upd(i + 1, j + 1, a[i+1][j+1], 1);
            }
        for (int i = 0; i < v; i++)
            b[i] = _b[i+1];
        m_x1 = m_x1 + 1;
        m_x2 = m_x2 + 1;
        m_y1 = m_y1 + 1;
        m_y2 = m_y2 + 1;
/*
        for (int k = 0; k < v; k++) {
            printf("fen %i\n", k);
            for (int i = 0; i <= n; i++) {
                for (int j = 0; j <= m; j++)
                    printf("%d ", fen[i][j][k]);
                printf("\n");
            }
        }*/

        int t = 0;
        for (int i = 0; i < q; i++) {
            if (m_y2[i] == -1) {
                upd(m_x1[i], m_y1[i], m_x2[i] - 1, 1);
                upd(m_x1[i], m_y1[i], a[m_x1[i]][m_y1[i]], -1);
                a[m_x1[i]][m_y1[i]] = m_x2[i] - 1;
            }
            else {
                sol[++t] = 0;
                for (int z = 0; z < v; z++)
                    if (query(m_x1[i], m_y1[i], m_x2[i], m_y2[i], z) == b[z])
                        sol[t]++;
            }
        }
    }
}


void Resi(int _n, int _m, int _q, int _v, int** _a, int* _b, int* _x1, int* _y1, int* _x2, int* _y2, int* sol) {
    memset(po_q::cnt, 0, sizeof po_q::cnt);
    if (_v <= po_v::max_v)
        po_v::Resi_v(_n, _m, _q, _v, _a, _b, _x1, _y1, _x2, _y2, sol);
    else
        po_q::Resi_q(_n, _m, _q, _v, _a, _b, _x1, _y1, _x2, _y2, sol);
}