#ifndef __CODE_H__
#define __CODE_H__

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
/*
	N i M su dimenzije matrice, Q je broj upita,
	V je broj razlicitih brojeva u matrici.

	Svaki upit ima ili 4 broja x1, y1, x2, y2 >= 0,
	ili u slucaju apdejta ima x1, y1 = koordinate, x2 = nova
	vrednost, y2 = -1
*/
vector <vector<int> > Sum(vector <vector<int> > A,vector<vector<int> > B){//A.size()==B.size();

for(int i=0;i<A.size();i++){
  for(int j=0;j<A[i].size();j++){
    A[i][j]+=B[i][j];
  }
}
return A;
}
 vector<int> C;//Count
vector<vector<int> > MSeg;
vector<vector<vector<int> > > VSeg;//Bice implicitno kasnije

void Update(int x,int y,int Position,int value){//x,y su za N odnosno M veci od Njihovih realnih vrednosti
    //Position je null indeksiran;
    //Value je 0 ili 1
VSeg[x][y][Position]=value;
for(int i=y/2;i>=1;i/=2){
    VSeg[1][i][Position]= VSeg[1][i*2][Position]+ VSeg[1][i*2+1][Position];
}
for(int i=y;i>=1;i/=2){
    for(int j=x/2;j>=1;j/=2){

    VSeg[j][i][Position]=VSeg[j*2+1][i][Position]+VSeg[j*2][i][Position];
    }
}
}
int Calculate(int LV,int RV,int LM,int RM,int Position){
int sol=0;
vector<int> Indices;
vector<int> BigIndices;
while(LM!=RM){
    if(LM%2){
        Indices.push_back(LM);
        LM++;
    }
    if(!(RM%2)){
        Indices.push_back(RM);
        RM--;
    }
    RM/=2;
    LM/=2;
}
 Indices.push_back(RM);

while(LV!=RV){
    if(LV%2){
        BigIndices.push_back(LV);
        LV++;
    }
    if(!(RV%2)){
        BigIndices.push_back(RV);
        RV--;
    }
    LV/=2;
    RV/=2;
}
 BigIndices.push_back(RV);

 for(int i=0;i<BigIndices.size();i++){
    for(int j=0;j<Indices.size();j++){
        sol+=VSeg[BigIndices[i]][Indices[j]][Position];
    }
 }
 return sol;
}
void Resi(int N, int M, int Q, int V, int** A, int* B,int* X1, int* Y1, int* X2, int* Y2, int* O){
C.resize(V,0);
MSeg.resize(M*2+1,C);
VSeg.resize(N*2+1,MSeg);
for(int x=N;x<N*2;x++){
for(int i=M;i<M*2;i++){

Update(x,i,A[x-N+1][i-M+1]-1,1);
}

}
int Br=0;
for(int i=1;i<=Q;i++){
    if(Y2[i]==-1){
        Update(N+X1[i]-1,M-1+X2[i],A[X1[i]][X2[i]]-1,0);
          Update(N+X1[i]-1,M-1+X2[i],Y1[i]-1,0);
          A[X1[i]][X2[i]]=Y1[i];
    }
    else{
            Br++;

   for(int x=0;x<V;x++){
    if(Calculate(Y1[i],Y2[i],X1[i],X2[i],x)==B[x+1]){
        O[Br]++;
    }
   }
    cout <<O[Br]<<endl;
    }
}

}

#endif /* __CODE_H__ */